* Version 2.29, May 16, 2003

- Implemented a small file explorer widget which is tightly integrated into
  xrmap's file menu. Should be useful to simplify the use of xrmap for
  people unfamiliar with xrmap's internals.

- Improvement in the emx scrollbar (to make it more responsive).

- Now using Imakefile in editkit.

- Minor bug fixes.

* Version 2.28, May 10, 2003

- Implemented -arc option (procedures for dealing with ARCINFO data format,
  sort of... : check 'ARCINFO' documentation).

- Implemented -dump option (dump vector map data into some file, either in
  ASCII or JPD format). The ASCII output can be edited by hand, and then 
  fed back to xrmap to produce modified vector map data.

- As a result of the above, it became possible/easy to modify the 
  original CIA Word Data Bank 2 to include new international border lines
  appeared after 1990. Users *should* either download the new version,
  or upgrade their old JPD vector map data as explained in VECTORMAP,
  or use the tools/upgrade/upgrade_WDB2 script.

- Replaced German messages with an improved version contributed by 
  Peter Dyballa <Peter.Dyballa@Nols.de>

* Version 2.27, April 26, 2003

- Implemented +dms option (degree-minute-second mode)

- Implemented background pixmaps and themes, with related command line
  options -pixmap and -theme, and configuration of themes within the GUI

- Created four built-in themes ("default", "cloudy", "coffee", "sea")

- Modified the no-edit mode in the 'emx' editor. Everything is now
  enabled except saving a file. Especially, it becomes possible to
  use key bindings in no-edit mode.

- Added a few more examples, now located in ./examples

- Corrected bug in .eps output (incorrect centering in spherical mode)


* Version 2.26-rev2, April 4, 2003

- In PixmapDrawString() procedure, improved speed of textbox overlapping 
  test by about 30 times. As a consequence, displaying text is now almost 
  as fast as it was when overlapping remained untested.

* Version 2.26, March 31, 2003

- Added -coordinates option. This is a switch for drawing coordinates
  of grid lines (meridians, parallels).

- Added +smartlabels option. Useful to avoid overlapping labels on the map.
  The option is enabled with +, disabled with -.

- Changed the default sizes for city labels. They now appear under smaller
  zoom values - this is quite OK with the new +smartlabels option.

- Minor bugs corrected.

* Version 2.25, January 27, 2003

- Added .eps (enhanced PostScript) as a new output format. This produces
  vector data in the PostScript, rather than a plain bitmap PostScript
  image. As a result, printed pages look much more accurate -- also,
  the output can be edited by hand (with some PostScript expertise...). 
  One draw-back is that printing can take as long as 10 minutes for the 
  whole Earth.

- Key "&" (and "Print Screen" as well) is bound to printing the map in 
  enhanced PostScript mode. Printing maps is now very easy!

- The printing routines (finally) work also when user defined features are 
  drawn on the maps -- earlier versions were very picky with this. Speed
  and efficiency have been improved as well.

- Added button hints in data window, and slightly changed the widget look 
  and feel. 

- Improved algorithm for detecting whether a coastline (river, etc) segment 
  is in current scene -- thus avoiding some segments to disappear near polar
  latitudes. Problem discovered by Serge Gagnon <gagnon__s@videotron.ca>

- Updated the CIA factbook to the 2002 edition. Improved integration with 
  the CIA factbook, by adding buttons to access the html files and related 
  maps. This required a slight modification in the format of <countries>
  data in the 'Locations' file (12 fields now).

- Made provisions for the possibility of translating the factbook country
  sheets from English to other languages. If a country sheet XY.txt is
  translated to French (say), it should be put in the   rmap/factbook/fr/
  subdirectory. If a translation is not found, it defaults back to the
  rmap/factbook/en subdirectory, and as a last resource to  rmap/factbook/

- The country maps accessed from the data window can now be loaded in
  .pdf, .gif, .png or .jpg formats.

- Merged suggestion by Terry Loveall in editkit (possibility of doing
  a search line at startup).

- A lot of small bugs fixed.

* Version 2.24, December 9, 2002

- Added button to data window, allowing to link a PDF map to each country.
  Users still have to download the adquate maps, e.g. from the United
  Nations site  http://www.un.org/Depts/Cartographic/english/htmain.htm
- Minor bug fixes in option parameters
- Updated Spanish dialogs, thanks to Ricardo Mones Lastra
  <mones@trasgu.aic.uniovi.es>
- Corrected several French/Spanish peak coordinates, thanks to
  Guy Laffaille <laff@darboux.math.univ-montp2.fr>

* Version 2.23, July 10, 2002

- Improvements and bug fixes in draw_location(), correcting a segfault 
  (which fortunately occurred only in some strange and rare conditions...)
- Bug fix in draw_string().

* Version 2.22, July 9, 2002

- Added code to handle airports and astronomical observatories
- Integrated list of airports (8805 airports!) and 90 astronomical entries 
  into the 'Locations' file
- New "Miscellaneous" section in the help menu

* Version 2.21, July 4, 2002 (not officially released)

- Improvements in the map edition mode
- Bug fixes

* Version 2.20, June 30, 2002 (not officially released)

- Reorganized a little bit the code into distinct sections
- Added a new search item (browsing through the list of previous positions)
- Corrected minor bug in temporary files handling
- Improved search option in such a way that coordinates can be passed as extra
  parameters, e.g. -search "Paris|45.0,2.0"
- Xrmap now includes a syntax for drawing user defined features on the maps 
  (labels, icons, polygons, regions, ellipses...). This is available through
  -define command line options, or from the <defines> section of the
  rcfile (read MAPEDIT for details).
- Maps can be saved in .rc format, in such a way that the output can
  be fed back to `xrmap -rcfile *`. The key shortcut * opens the editor
  and loads the rcfile just saved. In this way, map parameters and
  defines can be edited easily. 
- Improvements in the editkit (the editor now has a scrollbar).
- If 'emx' is used as the editor, key binding Alt-M within 'emx' renders 
  the edited map.
- Xrmap no longer needs an xterm and a pager to browse the man page; 
  by default, 'emx -edit 0' (no-edition mode) is used for that purpose.
- Added a browsable Documentation section from the menu window
- Xrmap no longer complains if the CIA_WDB2.jpd vector data are not found. 
  Actually, these data will become fully optional when the topography layer
  is implemented.

* Version 2.13, May 28, 2002

- Implemented selection of new zone area when clicking and dragging with
  mouse button 3. This makes zooming much more comfortable (hopefully!)
- Cycling through previous positions now remembers which zoom factor was
  used.
- The zoom factor can no longer exceed 1000, so as to avoid display
  artefacts at higher values (this is already beyond what the vector map 
  can practically offer).
- Added a lightweight editor (editkit), thanks to joint work with
  Terry Loveall <loveall@qwest.net> This allows very a quick loading of
  the editor window, even on machines that are low on resources.
- Added Spanish messages, thanks to Ricardo Mones Lastra
  <mones@trasgu.aic.uniovi.es>
- Corrected minor bugs (update menu and window titles when a change of 
  language occurs, don't show a marked city which is no longer visible, 
  display correctly meridians/parallels even with high zoom values, etc...)

* Version 2.12, April 4, 2002

- Partially rewrote the GUI, so as to have a separate parameter/commmand
  window. The shortcut "!" now opens an expert "command line mode".
- Introduced some improvements in the X routines. The display should now 
  be quicker and smoother, and should avoid all that ungraceful 
  flickering that did occur, especially when using xrmap on a remote 
  display.
- A "Recenter" button is now apparent in the city/location window.
- Updated Polish dialogs by Wojtek Andralojc <wojtekandralojc@poczta.fm>
- Some minor coordinate corrections made in the Locations file
- A list of 8500 airport locations is now included in the tools/extradata
  subdirectory (but not yet integrated in the GUI...)
- A "picons" directory is also there. Will possibly be used later when 
  the editing capabilities of xrmap will be developed.

* Version 2.11, March 18, 2002

- Corrected some incorrect coordinates in Italian mountain peaks (mostly,
  changed negative longitudes to positive ones...)
- Changed again format of Locations file, so that country data are taken
  into account whenever this makes sense.
- Added a "List of countries & territories" options in the search routine
- Added one button to the data window so as to start playing national hymns.
  Midi files are provided, with 'timidity' as the default MIDI player.
  This can be changed with the new option -musicplayer
- The File menu now has a new submenu 'External programs'
- Applied an idea of Guillaume Allègre <Guillaume.Allegre@imag.fr> to
  improve the speed of xrmap under smaller values of the zoom. The idea
  was to skip unneeded interpolation points, since they become anyway
  indistinguishable at that scale. This simple idea has very spectacular 
  effects (increase of speed by at a factor at least 5). Thanks Guillaume!
- Added a new option -accuracy that affects the accuracy of polygonal lines
  of the vector map, as well as the time needed for rendering.

* Version 2.10, March 4, 2002

- The format of the Locations file has slightly changed (and for this
  reason, is no longer compatible with older versions)
- An extensive support has been added for locations of peaks and mountains,
  along with new options -peakmarks -peaksizes (the previous option 
  -cityspots has been renamed -citymarks)
- Xrmap can now display data from the CIA factbook, a public domain set 
  of data maintained by the CIA, detailing a rich collection of facts
  about all world countries :
     http://www.cia.gov/cia/publications/factbook/
  (Here, the data have been compressed and converted to plain ASCII.)
- Xrmap includes a rather extended list of National anthems and hymns 
  (as midi files) - however support for playing the midi files is not yet 
  there...
- The data window size has been increased so that all these new data fit in,
  including information on currency, international telephone code, etc.
- Xrmap now has an inline link for calling an external editor in which the
  city/location/country data can be saved and edited. A related new option
  -editor has been introduced, so that a default editor can be selected.
- New options -tropics, +tropics (they should have been there earlier but
  were just forgotten...)
- Former option -thresholds has been replaced by to options -marksteps
  and -namesteps controlling separately the display of marks and names
- Xrmap doesn't redraw the vector map when changes only involve rendering
  parameters that don't affect the geographic data. Rendering has therefore
  become much faster in these cases...

* Version 2.05, January 19, 2002

- Support for Cylindric, Sinusoidal, Elliptic and Mollweide projections
  (all these projections are area preserving, except for the Elliptic
  projection which is only approximately area preserving, with maximal
  distortion 8% near the Equator)
- Added Equator, Tropics and Polar Circles (suggestion by
  François Massonneau <frmas@free.fr>), together with new color
  option for these
- Corrected coordinates of Dover (GB) in 'Locations' file (lat=51.13)
- Changed key binding 't' to switch Tropics on/off (the not so useful
  transparency feature is no longer available from key shortcuts)
- Implemented BackSpace key binding, used to return to previous position
- Slightly changed the default color scheme
- Fixed some problems with vanishing of parallels/meridians under
  higher zoom values (noticed by Eelco Vriezekolk <eelco@nexus.com.na>)
- Minor bug corrections (Activate! didn't work in case of a city search,
  when only one item had been found; smarter color handling)

* Version 2.04,  January 4, 2002

- Up, Down, PageUp and Tab arrow keys can now be used to switch fields 
  in the various menus and submenus
- Improvements in the Save/Preview/Print procedure. Printing and
  previewing (with an external utility) are better supported
- Related new options -imviewer, -printcmd
- Corrected long standing bug in -spacing option (the bug made it 
  ineffective, already for most of the earlier versions...)
- Changed option names -spacing -slatitude -slongitude to resp.
  -gsp(acing) -gslat(itude) -gslon(gitude), so as to suggest
  "grid spacing" in a more explicit way
- Output images can now be either left uncompressed (default) or be
  compressed. New options +compress and -compress have been introduced
  for that purpose.
- Added Polish messages, thanks to Wojtek Andralojc
  <wojtekandralojc@poczta.fm>
- The language of menus can be set interactively from the GUI as 
  well as from the command line options
- Improvements in window refreshing procedure
- Minor bug fixes - e.g. the transparent Xpm color "None" is now handled
  correctly and set to background color with flags that are not
  rectangular (e.g. Ohio State).

* Version 2.03,  December 24, 2001

- Bug fixes (stupid problem with letter k...)
- Stability of windows and buggy behaviour of refreshing procedure
  under some window managers (including default KDE...) fixed

* Version 2.02,  December 22, 2001 (not announced)

- Partly rewrote the GUI with cascading menus to make it more powerful 
  and more intuitive
- Introduced rudimentary emacs bindings in the text input field
- The major part of the menu can be accessed via key shortcuts
- Renamed again (back to what it was in version 1.3...) option -datafile 
  to -locfile, to fit better with the new GUI behavior
- The option -language can now be set from the RCfile (bug mentioned
  some time ago by François Massonneau)
- The search procedure can search on other fields than the name (e.g.
  by country or by administrative region).  Added -field option to
  accommodate this new feature.
- The search procedure now opens the City window when a city is clicked 
  from within the widget list -- even though it might not be yet activated
- More graceful behavior when an incorrect color or font is entered:
  xrmap just rejects the choice
- Xrmap no longer hangs up if something goes wrong at startup. Instead,
  it opens a (possibly blank) window and issues a warning
- Added in extradata/ a comprehensive list of peaks and highest points
  for all world countries

* Version 2.01,  December 6, 2001

Bug fixes : 
- Search algorithm sometimes didn't properly handle wildcards - and 
  therefore didn't find existing data !
- Segfault crash when parsing options that would have been incorrectly 
  specified, instead of producing a nice error message
- Fixed some problems appearing when trying to load non existent flags
- Replaced some obsolete tags by newer ones (NAT instead of US)
- added exit(0) in tools/preproc.c, which prevents the make process to
  abort on OpenBSD; removed unnecessary #include sys/timeb.h in
  xrmap.c (reported by Christian Weisgerber <naddy@mips.inka.de>)

GUI improvements:
- Nicer default color scheme (by François Massonneau)
- New -hierarchy option, enabling users to specify the precedence
  of features being drawn (so that, e.g., national boundaries which
  coincide with rivers are by default not overwritten by those)
- Reformatted the parameter widget into two widgets (parameter,display) 

* Version 2.0,  December 3, 2001

- Xrmap now uses a new JPD data format which only takes about 1/4 of the
  previous REZ format hard disk space (without data loss, of course). 
  Several changes in the core engine have been necessary to achieve this. 
  The result is a very noticeable increase in speed and responsiveness.
  Bigendian/smallendian nature of the CPU is no longer an issue.
- the -item option has been replaced by -color with a new syntax
- the -menu option now needs a (one character) parameter
- added -memory option to the effect of still increasing speed (but with
  the trade-off of enlarging RAM usage a lot, by about 10 MB).
- city data are now shown in a new window, and there are a few new
  functions available from there, such as showing a big flag (click
  on it with left button) or recentering the map on the selected city 
  (click with right button).
- simplification of the cascading menus
- improved search procedure, accepting the standard wildcard *
  (suggestion by François Massonneau <frmas@free.fr> )
- improved the search widgets - the full list of matching items now
  appears on screen, and can be scrolled and clicked
- added sky and stars to fill empty zones (in case the main window is not 
  entirely covered by the Earth)
- removed -vectordata option, which is now handled by the external utility
  tools/jpd2else/buildvmf

* Version 1.7,  November 9, 2001 (not announced)

- improved detection of bigendian processors, thanks to Debian maintainer
  Branden Robinson <branden@debian.org>
- fixed some minor compilation problems noticed by
  Osamu Ajiki <osam-a@astroarts.co.jp> and
  Petter Reinholdtsen <pere@hungry.com>
- substantially improved speed of operation, although with a trade-off
  of using slightly more RAM - the improvement is by a factor 100 or more 
  when the CIA map is left uncompressed. The speed inefficiency in that
  case was noticed by Harold van Oostrom <xrmap@lanceerplaats.nl>

* Version 1.6,  November 5, 2001

User visible changes:

- Internationalization 
- New options -language (set the language, if the corresponding localization
  file exists) and -search (search a location right away at start-up)
- Improved inline help: key shortcuts are now explained in greater detail
- UI improvements, to accommodate new internationalization features
- xrmap now has an extended support for time zones and calculates local 
  time of cities
- work-around for (very small) bug in CIA_map.rez
- corrected about 450 incorrect population figures (agglomerations 
  population numbers were given rather than the cities themselves)

Developer changes:

- a lot of code clean-ups. The code should be easier to read/understand
- introduced a (simple) preprocessor for compiling the hardcoded messages
- improved the (I)makefile, dependency issues should now work fine

* Version 1.5,  October 26, 2001

- Added PostScript export and printing routines
- Implemented search of cities and locations
- Corrected some wrong city coordinates
- Minor bug fixes

* Version 1.4,  October 17, 2001

- A much extended database of cities and locations (almost 20000 cities,
  hundreds of countries/lands/islands...)
- option -locfile changed to -datafile, since it also contains data for
  various geographic features: timezones, cities, locations...
- new option -locfilter
- Locations can be of land or water type, and 2 distinct colors can
  be used for them
- Positioning of labels is now much more sophisticated (8 possibilities
  of adjusting position, see <locations> section in the 'Locations' file)
- A `Quit' slot in the `File' menu has been added
- The map can now be saved in .xpm as well as .ppm format
- The "reversing color" routine  now only affects the map colors
- Bug fixes

* Version 1.3,  September 10, 2001

- New format for cities and locations, with the inclusion of a very
  comprehensive database of world cities presenting for each city
  its population figure, national and international rank, administrative 
  area, timezone etc...
- New options -populsteps and -cityfilter.
- Option -cityfile changed to -locfile
- Details of a city are now shown by clicking on the spot on the map. 
  National and regional flags are shown as well.
- New options -menu and -resetcolors (for pseudo-color screens)
- The command line section of .xrmaprc starts with <commandlines> reather
  than !commandlines, in order to be consistent with the new syntax
  of cities and locations.
- Bug fixes (many)

* Version 1.3pre1,  August 23, 2001

- New -placename option to vary (or not) the position of city names
- The placename and transparency flags are now accessible from the
  "Parameters" widget

* Version 1.2,  August 22, 2001

- UI improvements: file menu, smarter help comments
- New options: -spotsizes, -thresholds
- The city data base has become an external file that can be reread and
  reloaded at runtime
- Scheduling of X events improved and smoother
- Bug fixes

* Version 1.1,  August 20, 2001

- UI improvements: cascading menus
- Possibility to write PPM images as output
- Bug fixes

* Version 1.0,  August 14, 2001

- Initial release
- Configuration via command line and built-in command editor